--[[----------------------------------------------------------------------------
-- Duplex.MCUPro
----------------------------------------------------------------------------]]--

duplex_configurations:insert {
  -- configuration properties
  name = "MCU Pro Effect Mode",
  pinned = true,
  -- device properties
  device = {
    class_name = "MCUPro",          
    display_name = "MCUPro",
    device_port_in = "MCU Pro USB v3.1",
    device_port_out = "MCU Pro USB v3.1",
    control_map = "Controllers/MCUPro/Controlmaps/MCUPro.xml",
    thumbnail = "Controllers/MCUPro/MCUPro.bmp",
    protocol = DEVICE_PROTOCOL.MIDI				},

applications = {




--------------------------------------------------------------
--   start with common controls betwwen configurations
--------------------------------------------------------------

-- swithching configuration control
SwitchConfiguration = {
	mappings = {
		goto_previous = {
			group_name = "Display",
			index = 1,						},

		goto_next = {
			group_name = "Display",
			index = 2,						},
	}									},

-- track selection control
TrackSelector = {
	mappings = {
	   prev_page = {group_name = "Fader_Bank",index = 1,},
	   next_page = {group_name = "Fader_Bank",index = 2,},
	   prev_track = {group_name = "Fader_Bank",index = 3,},
	   next_track = {group_name = "Fader_Bank",index = 4,},
	   select_track = {group_name = "Select",index = 1,},
	   select_first = {group_name = "Fader_Bank",index = 5,},
        select_sends = {group_name = "Fader_Bank",index = 6,},
      },									},

-- transport control

Transport = {
	mappings = {
		goto_previous = {group_name = "Transport",
			index = 1,						},
		goto_next = {group_name = "Transport",
			index = 2,						},
		stop_playback = {group_name = "Transport",
			index = 3,						},
		start_playback = {group_name = "Transport",
			index = 4,						},
		edit_mode = {group_name = "Transport",
			index = 5,						},
		follow_player = {group_name = "Transport2",
			index = 2,						},
		loop_pattern = {	group_name = "Transport2",
			index = 3,						},
		metronome_toggle = {group_name = "Transport2",
			index = 4,						},
		block_loop = {group_name = "Transport2",
			index = 5,						},
-- to modify to better position
		bpm_increase = {	group_name = "Modifiers",
			index = 2,						},
		bpm_decrease = {	group_name = "Modifiers",
			index = 1,						},
	},
	options = {	}						},



-- functions buttons 1 to 8 used for renoise tabs views

MidTabsTracker = {	application = "MidiActions",
	mappings = {control = {group_name = "Function",index = 1}},
	options = {action = "GUI:Middle Frame:Show Pattern Editor [Trigger]"},    								},

MidTabsMixer = {		application = "MidiActions",
	mappings = {control = {group_name = "Function",index = 2}},
	options = {action = "GUI:Middle Frame:Show Mixer [Trigger]"},   								},

SideWindowSampler = {	application = "MidiActions",
      mappings = {control = {group_name = "Function",index = 3}},
      options = {action = "GUI:Middle Frame:Show Instrument Sample Editor [Trigger]"},
					},
SideWindowPlugin = {	application = "MidiActions",
      mappings = {control = {group_name = "Function",index = 4}},
      options = {action = "GUI:Middle Frame:Show Instrument Plugin Editor [Trigger]"},						},

SideWindowMidi = {	application = "MidiActions",
      mappings = {control = {group_name = "Function",index = 5}},
      options = {action = "GUI:Middle Frame:Show Instrument Midi Editor [Trigger]"},							},

UpperTabView = {		application = "MidiActions",
      mappings = {control = {group_name = "Function",index = 6}},
      options = {action = "GUI:Upper Frame:Show Upper Frame [Set]"},									},

UpperTabsPrev = {	application = "MidiActions",
      mappings = {control = {group_name = "Function",index = 7}},
      options = {action = "GUI:Upper Frame:Select Previous [Trigger]"},								},

DiskBrowser = {	application = "MidiActions",
      mappings = {control = {group_name = "Function",index = 8}},
      options = {action = "GUI:Show Disk Browser [Trigger]"},
    },





--------------------------------------------------------------
--   specific controls of this configuration
--------------------------------------------------------------

-- application for configuration init
MCUPro_EffectMode = {
	mappings = {	},
	options = {	}						},

MCUPro_MixerNoDisplay = {
	mappings = {
		solo = {group_name = "Solo",},
		mute = {group_name = "Mute",},
		levels = {group_name = "Faders",},
		master = {group_name = "Master_Fader",},
		mode = {group_name = "Transport2",index = 1,},},
	options = {
		invert_mute = 0,
		follow_track = 1,
		take_over_volumes = 2,}				},

MCUPro_EffectDisplay = {
	mappings = {
		device_prev = {group_name = "Vpot_assign",index = 1,},
		device_next = {group_name = "Vpot_assign",index = 2,},
		preset_prev = {group_name = "Vpot_assign",index = 3,},
		preset_next = {group_name = "Vpot_assign",index = 4,},
		param_prev = {group_name = "Vpot_assign",index = 5,},
		param_next = {group_name = "Vpot_assign",index = 6,},
		parameters = {group_name = "Encoders",},
	},									},




--------------------------------------------------------------
--   garbage to clean
--------------------------------------------------------------






InstruDecrease = {
      application = "MidiActions",
      mappings = {control = {group_name = "Function",index = 9}},
      options = {action = "Navigation:Instruments:Decrease Current Instrument [Trigger]"},
    },
InstruIncrease = {
      application = "MidiActions",
      mappings = {control = {group_name = "Function",index = 10}},
      options = {action = "Navigation:Instruments:Increase Current Instrument [Trigger]"},
    },
OctDecrease = {
      application = "MidiActions",
      mappings = {control = {group_name = "Function",index = 11}},
      options = {action = "Transport:Edit:Decrease Octave [Trigger]"},
    },
    OctIncrease = {
      application = "MidiActions",
      mappings = {control = {group_name = "Function",index = 12}},
      options = {action = "Transport:Edit:Increase Octave [Trigger]"},
    },






    LPB_Decrease = {
      application = "MidiActions",
      mappings = {control = {group_name = "Modifiers",index = 3}},
      options = {action = "Transport:Song:Decrease LPB [Trigger]"},
    },
    LPB_Increase = {
      application = "MidiActions",
      mappings = {control = {group_name = "Modifiers",index = 4}},
      options = {action = "Transport:Song:Increase LPB [Trigger]"},
    },







PrevPattern = {
      application = "MidiActions",
      mappings = {control = {group_name = "Automation",index = 2}},
      options = {action = "Navigation:Sequencer:Decrease Current Pattern [Trigger]"},
    },
NextPattern = {
      application = "MidiActions",
      mappings = {control = {group_name = "Automation",index = 3}},
      options = {action = "Navigation:Sequencer:Increase Current Pattern [Trigger]"},
    },








Recorder = {
      application = "MidiActions",
      mappings = {control = {group_name = "Utils",index = 1}},
      options = {action = "GUI:Dialogs:Show Sample Recorder [Set]"},
    },


StartRecord = {
      application = "MidiActions",
      mappings = {control = {group_name = "Utils",index = 2}},
      options = {action = "Transport:Record:Start/Stop Sample Recording [Trigger]"},
    },

Redo = {
      application = "MidiActions",
      mappings = {control = {group_name = "Utils",index = 3}},
      options = {action = "Transport:Record:Redo Last Action [Trigger]"},
    },


Undo = {
      application = "MidiActions",
      mappings = {control = {group_name = "Utils",index = 4}},
      options = {action = "Transport:Record:Undo Last Action [Trigger]"},
    },
    

LoopBlockPrev = {
      application = "MidiActions",
      mappings = {control = {group_name = "Transport2",index = 6}},
      options = {action = "Transport:Playback:Move Loop Block Backwards [Trigger]"},
    },
LoopBlockNext = {
      application = "MidiActions",
      mappings = {control = {group_name = "Transport2",index = 7}},
      options = {action = "Transport:Playback:Move Loop Block Forwards [Trigger]"},
    },





PrevTrack = {
      application = "MidiActions",
      mappings = {control = {group_name = "Cursor",index = 1}},
      options = {action = "Navigation:Tracks:Select Previous Track [Trigger]"},
    },
NextTrack = {
      application = "MidiActions",
      mappings = {control = {group_name = "Cursor",index = 2}},
      options = {action = "Navigation:Tracks:Select Next Track [Trigger]"},
    },
PrevSeqPos = {
      application = "MidiActions",
      mappings = {control = {group_name = "Cursor",index = 3}},
      options = {action = "Navigation:Sequencer:Select Previous Sequence Pos [Trigger]"},
    },
NextSeqPos = {
      application = "MidiActions",
      mappings = {control = {group_name = "Cursor",index = 4}},
      options = {action = "Navigation:Sequencer:Select Next Sequence Pos [Trigger]"},
    },


	





   

    








    TrackSelector = {
      mappings = {
        prev_page = {
          group_name = "Fader_Bank",
          index = 1,
        },
        next_page = {
          group_name = "Fader_Bank",
          index = 2,
        },
        prev_track = {
          group_name = "Fader_Bank",
          index = 3,
        },

        next_track = {
          group_name = "Fader_Bank",
          index = 4,
        },

        select_track = {
          group_name = "Select",
          index = 1,
        },
        select_first = {
          group_name = "Fader_Bank",
          index = 5,
        },
        select_sends = {
          group_name = "Fader_Bank",
          index = 6,
        },
      },
    },
    Navigator = {
      mappings = {
        blockpos = {
          group_name = "Rec",
          orientation = ORIENTATION.HORIZONTAL,
        },
      }
    },
    
  }
}



